import 'dart:math' as math;
import 'package:dartterm/assets.dart';
import 'package:dartterm/game/sitemode/sitemode.dart';
import 'package:dartterm/gen/generator.dart';
import 'package:dartterm/skreek.dart';
import 'package:dartterm/terminal.dart';
import 'package:dartterm/world/level.dart';

void main() async {
  var level = await getLevel();

  await sitemode(level);
}
/*
void main() async {
  var descriptor = "generic";
  while (true) {
    at(0, 0).clear();
    at(0, 0).puts("Hello, bats!");
    at(0, 2).fg(Palette.subtitle).small().puts("Beware of the bat!");
    at(4, 4)
        .bg(Palette.subtitle)
        .fg(Palette.defaultBg)
        .big()
        .highlight()
        .act(Act(
            isDefault: true,
            label: "Strong!",
            callback: () async {
              log("strong!");
              descriptor = "strong";
            }))
        .act(Act(
            label: "Nocturnal!",
            callback: () async {
              log("nocturnal!");
              descriptor = "nocturnal";
            }))
        .puts("ALTER BAT");

    at(4, 8).normal().puts("A $descriptor bat!");

    // await zzz(1.0);
    await waitMenu();
  }
}
*/

Future<Level> getLevel() async {
  Vaults vaults;
  while (true) {
    Vaults? maybeVaults =
        getVaultsIfAvailable("assets/images/vaults/house1.png");

    if (maybeVaults != null) {
      vaults = maybeVaults;
      break;
    }
    await zzz(0.1);
  }
  return Generator(math.Random(0), vaults).generateLevel(Requirement(
      16,
      32,
      16,
      18,
      DirectionSet({
        Direction.up,
        Direction.down,
        Direction.left,
        Direction.right,
      })));
}
